diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java
index 12909291f..e16c08709 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelLantern.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
@@ -17,7 +18,13 @@ public class BlockModelLantern<T extends Block> extends BlockModelStandard<T> {
         boolean isHanging = (meta & 0b00000001) == 0;
         boolean isAngled = (meta & 0b00000010) != 0;
 
-        float brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        float brightness = 1.0f;
+        if(LightmapHelper.isLightmapEnabled()) {
+        	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+        }else {
+        	brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        }
+        tessellator.setColorOpaque_F(brightness, brightness, brightness);
 
         float yOffset = isHanging ? 0f : 0.375f;
 
@@ -124,8 +131,6 @@ public class BlockModelLantern<T extends Block> extends BlockModelStandard<T> {
         double hookMinV = texIndex.getSubIconV(onePix * 6);
         double hookMaxV = texIndex.getSubIconV(onePix * 10);
 
-        tessellator.setColorOpaque_F(brightness, brightness, brightness);
-
         // Render sides int
         tessellator.addVertexWithUV(intMaxX, intMinY, intMinZ, sideMinU, sideMaxV);
         tessellator.addVertexWithUV(intMinX, intMinY, intMinZ, sideMaxU, sideMaxV);
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
index e7955c3ee..4d1034b65 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
@@ -54,12 +55,18 @@ public class BlockModelLever<T extends Block> extends BlockModelStandard<T>{
         {
             renderBlocks.overrideBlockTexture = null;
         }
-        float f3 = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
-        if(Block.lightEmission[block.id] > 0)
-        {
-            f3 = 1.0F;
+        float brightness = 1.0f;
+        if(LightmapHelper.isLightmapEnabled()) {
+        	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+        }else {
+			if(Block.lightEmission[block.id] > 0) {
+				brightness = 1.0f;
+			}else {
+				brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+			}
         }
-        tessellator.setColorOpaque_F(f3, f3, f3);
+        
+        tessellator.setColorOpaque_F(brightness, brightness, brightness);
         IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.BOTTOM, l);
         if(renderBlocks.overrideBlockTexture != null)
         {
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelPumpkinPie.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelPumpkinPie.java
new file mode 100644
index 000000000..ad91d66e4
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelPumpkinPie.java
@@ -0,0 +1,89 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockCake;
+import net.minecraft.core.block.BlockEdible;
+import net.minecraft.core.util.helper.Side;
+
+public class BlockModelPumpkinPie<T extends Block> extends BlockModelStandard<T>{
+    protected IconCoordinate sideTexture = TextureRegistry.getTexture("minecraft:block/pumpkin_pie_side");
+    protected IconCoordinate insideTexture = TextureRegistry.getTexture("minecraft:block/pumpkin_pie_inside");
+    protected IconCoordinate topTexture = TextureRegistry.getTexture("minecraft:block/pumpkin_pie_top");
+
+    public BlockModelPumpkinPie(Block block) {
+        super(block);
+    }
+
+    public void renderSliceSide(Tessellator tessellator, Block block, int x, int y, int z, Side side, boolean overrideTex) {
+        if(overrideTex)
+            renderBlocks.overrideBlockTexture = insideTexture;
+        renderSide(tessellator, block, x, y, z, side, 0);
+        if(overrideTex)
+            renderBlocks.overrideBlockTexture = null;
+    }
+
+    private void renderSlice(Tessellator tessellator, Block block, int x, int y, int z, int sliceX, int sliceZ) {
+
+        double onePix = 0.0625;
+        double sliceWidth = onePix * 8;
+
+        double xMin = 0.0F + (sliceWidth * sliceX);
+        double xMax = xMin + sliceWidth;
+
+        double zMin =  0.0F + (sliceWidth * sliceZ);
+        double zMax = zMin + sliceWidth;
+        double offsetXMin = sliceX == 0 ? onePix : 0;
+        double offsetXMax = sliceX == 1 ? onePix : 0;
+        double offsetZMin = sliceZ == 0 ? onePix : 0;
+        double offsetZMax = sliceZ == 1 ? onePix : 0;
+
+        boolean insideSouth = sliceZ == 0;
+        boolean insideNorth = sliceZ == 1;
+        boolean insideEast = sliceX == 0 ;
+        boolean insideWest = sliceX == 1;
+
+        maxSlices = ((BlockEdible) block).maxBites;
+        block.setBlockBounds(xMin + offsetXMin, 0.0F, zMin + offsetZMin, xMax - offsetXMax, 0.375F, zMax - offsetZMax);
+        renderSide(tessellator, block, x, y, z, Side.TOP, 0);
+        renderSide(tessellator, block, x, y, z, Side.BOTTOM, 0);
+        renderSliceSide(tessellator, block, x, y, z, Side.SOUTH, insideSouth);
+        renderSliceSide(tessellator, block, x, y, z, Side.WEST, insideWest);
+        renderBlocks.flipTexture = true;
+        renderSliceSide(tessellator, block, x, y, z, Side.NORTH, insideNorth);
+        renderSliceSide(tessellator, block, x, y, z, Side.EAST, insideEast);
+        renderBlocks.flipTexture = false;
+    }
+
+    @Override
+    public boolean render(Tessellator tessellator, int x, int y, int z) {
+        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
+
+        final int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+        renderBlocks.enableAO = true;
+        renderBlocks.cache.setupCache(block, renderBlocks.blockAccess, x, y, z);
+        int slices = 0;
+        for(int xSlice = 0; xSlice < 2; xSlice++){
+            for(int zSlice = 0; zSlice < 2; zSlice++) {
+                slices++;
+                if(meta >= slices)
+                    continue;
+                renderSlice(tessellator, block, x, y, z, xSlice, zSlice);
+            }
+        }
+
+        renderBlocks.enableAO = false;
+        return true;
+    }
+    @Override
+    public boolean shouldItemRender3d() {
+        return false;
+    }
+
+    public int maxSlices;
+
+
+
+}
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
index 7145f807d..5d5ff46ee 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
@@ -31,14 +32,26 @@ public class BlockModelRail<T extends BlockRail> extends BlockModelStandard<T> {
         {
             l &= 7;
         }
-        float f = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
-        if (renderBlocks.overbright)
-        {
-            i1 = getBlockOverbrightTexture(renderBlocks.blockAccess, x, y, z, 0);
-            if (i1 == null) return false;
-            f = 1.0f;
-        }
-        tessellator.setColorOpaque_F(f, f, f);
+		float brightness = 1.0f;
+		if(LightmapHelper.isLightmapEnabled()) {
+			if(renderBlocks.overbright) {
+				// TODO use correct skylight value, requires a getSavedLightValue method in WorldSource
+				tessellator.setLightmapCoord(LightmapHelper.getOverbrightLightmapCoord(0));
+			}else {
+				tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+			}
+		}else {
+			if(!renderBlocks.overbright) {
+				brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+			}
+		}
+		if(renderBlocks.overbright) {
+			i1 = getBlockOverbrightTexture(renderBlocks.blockAccess, x, y, z, 0);
+			if(i1 == null) {
+				return false;
+			}
+		}
+        tessellator.setColorOpaque_F(brightness, brightness, brightness);
         double d = i1.getIconUMin();
         double d1 = i1.getIconUMax();
         double d2 = i1.getIconVMin();
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
index fe78ba935..b76f7f84f 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
@@ -2,7 +2,10 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessalator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLanternFirefly;
 import net.minecraft.core.block.BlockRope;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
 public class BlockModelRope<T extends BlockRope>
@@ -14,13 +17,13 @@ extends BlockModelStandard<T> {
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         WorldSource world = renderBlocks.blockAccess;
-        boolean hasFloor = world.isBlockOpaqueCube(x, y - 1, z);
-        boolean hasBlockNegX = world.getBlockId(x - 1, y, z) == block.id;
-        boolean hasBlockPosX = world.getBlockId(x + 1, y, z) == block.id;
-        boolean hasBlockNegY = world.getBlockId(x, y - 1, z) == block.id || hasFloor;
-        boolean hasBlockPosY = world.getBlockId(x, y + 1, z) == block.id || world.isBlockOpaqueCube(x, y + 1, z);
-        boolean hasBlockNegZ = world.getBlockId(x, y, z - 1) == block.id;
-        boolean hasBlockPosZ = world.getBlockId(x, y, z + 1) == block.id;
+        boolean hasFloor = world.getBlock(x, y - 1, z) != null && world.getBlock(x, y - 1, z).canPlaceOnSurface();
+        boolean hasBlockNegX = canConnect(world, x, y, z, Side.WEST);
+        boolean hasBlockPosX = canConnect(world, x, y, z, Side.EAST);
+        boolean hasBlockNegY = canConnect(world, x, y, z, Side.BOTTOM) || hasFloor;
+        boolean hasBlockPosY = canConnect(world, x, y, z, Side.TOP);
+        boolean hasBlockNegZ = canConnect(world, x, y, z, Side.NORTH);
+        boolean hasBlockPosZ = canConnect(world, x, y, z, Side.SOUTH);
 
 
         boolean drawKnot =  !(hasBlockNegX && hasBlockPosX && !hasBlockNegY && !hasBlockPosY && !hasBlockNegZ && !hasBlockPosZ) &&
@@ -81,4 +84,19 @@ extends BlockModelStandard<T> {
 
         return true;
     }
+    private boolean canConnect(WorldSource worldSource, int x, int y, int z, Side side){
+        int blockX = x + side.getOffsetX();
+        int blockY = y + side.getOffsetY();
+        int blockZ = z + side.getOffsetZ();
+        Block _block = worldSource.getBlock(blockX, blockY, blockZ);
+        if (side == Side.BOTTOM){
+            if (_block instanceof BlockLanternFirefly && (worldSource.getBlockMetadata(blockX, blockY, blockZ) & 0b1) != 0){
+                return true;
+            }
+        } else if (side == Side.TOP) {
+            if (worldSource.isBlockOpaqueCube(blockX, blockY, blockZ) || BlockTags.CAN_HANG_OFF.appliesTo(_block)) return true;
+        }
+        if ((worldSource.getBlockMetadata(x, y, z) & 0b1000_0000) != 0 && worldSource.isBlockOpaqueCube(blockX, blockY, blockZ)) return true;
+        return _block == block;
+    }
 }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
index 3d2ae764f..2716a2b6c 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelSpikes.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockSpikes;
@@ -25,7 +26,12 @@ public class BlockModelSpikes<T extends Block> extends BlockModelStandard<T> {
         renderStandardBlock(tessellator, block, x, y, z);
 
         if(BlockSpikes.isSpikesUp(metaData)) {
-            float brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+            float brightness = 1.0f;
+            if(LightmapHelper.isLightmapEnabled()) {
+            	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+            }else {
+            	brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+            }
             tessellator.setColorOpaque_F(brightness, brightness, brightness);
             double uMin = texture.getIconUMin();
             double uMax = texture.getIconUMax();
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
index de235fe84..7d046bb50 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
@@ -14,12 +15,16 @@ public class BlockModelTorch<T extends Block> extends BlockModelStandard<T> {
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int l = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        float f = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
-        if(Block.lightEmission[block.id] > 0)
-        {
-            f = 1.0F;
+        float brightness = 1.0f;
+        if(LightmapHelper.isLightmapEnabled()) {
+        	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
+        }else {
+        	brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+        	if(Block.lightEmission[block.id] > 0) {
+        		brightness = 1.0F;
+        	}
         }
-        tessellator.setColorOpaque_F(f, f, f);
+        tessellator.setColorOpaque_F(brightness, brightness, brightness);
         double d = 0.4;
         double d1 = 0.5D - d;
         double d2 = 0.2;
diff --git a/src/main/java/net/minecraft/client/render/entity/ArrowRenderer.java b/src/main/java/net/minecraft/client/render/entity/ArrowRenderer.java
index 60fa80cc9..6cf990707 100644
--- a/src/main/java/net/minecraft/client/render/entity/ArrowRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/ArrowRenderer.java
@@ -12,11 +12,6 @@ public class ArrowRenderer extends EntityRenderer<EntityArrow>
     public void renderArrow(EntityArrow arrow, double x, double y, double z,
                             float yaw, float partialTick)
     {
-        if(arrow.yRotO == 0.0F && arrow.xRotO == 0.0F)
-        {
-            return;
-        }
-
         loadTexture("/item/arrows.png");
         GL11.glPushMatrix();
         GL11.glTranslatef((float)x, (float)y, (float)z);
diff --git a/src/main/java/net/minecraft/client/render/entity/PaintingRenderer.java b/src/main/java/net/minecraft/client/render/entity/PaintingRenderer.java
index 051eb176c..d5792995d 100644
--- a/src/main/java/net/minecraft/client/render/entity/PaintingRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/PaintingRenderer.java
@@ -68,26 +68,34 @@ public class PaintingRenderer extends EntityRenderer<EntityPainting>
                 tessellator.addVertexWithUV(minX, maxY, maxZ, backMaxU, backMinV);
                 tessellator.addVertexWithUV(minX, minY, maxZ, backMaxU, backMaxV);
                 tessellator.addVertexWithUV(maxX, minY, maxZ, backMinU, backMaxV);
-                tessellator.setNormal(0.0F, 1.0F, 0.0F);
-                tessellator.addVertexWithUV(maxX, maxY, minZ, topBottomMinU, topBottomMinV);
-                tessellator.addVertexWithUV(minX, maxY, minZ, topBottomMaxU, topBottomMinV);
-                tessellator.addVertexWithUV(minX, maxY, maxZ, topBottomMaxU, topBottomMaxV);
-                tessellator.addVertexWithUV(maxX, maxY, maxZ, topBottomMinU, topBottomMaxV);
-                tessellator.setNormal(0.0F, -1F, 0.0F);
-                tessellator.addVertexWithUV(maxX, minY, maxZ, topBottomMinU, topBottomMinV);
-                tessellator.addVertexWithUV(minX, minY, maxZ, topBottomMaxU, topBottomMinV);
-                tessellator.addVertexWithUV(minX, minY, minZ, topBottomMaxU, topBottomMaxV);
-                tessellator.addVertexWithUV(maxX, minY, minZ, topBottomMinU, topBottomMaxV);
-                tessellator.setNormal(-1F, 0.0F, 0.0F);
-                tessellator.addVertexWithUV(maxX, maxY, maxZ, sidesMaxU, sidesMinV);
-                tessellator.addVertexWithUV(maxX, minY, maxZ, sidesMaxU, sidesMaxV);
-                tessellator.addVertexWithUV(maxX, minY, minZ, sidesMinU, sidesMaxV);
-                tessellator.addVertexWithUV(maxX, maxY, minZ, sidesMinU, sidesMinV);
-                tessellator.setNormal(1.0F, 0.0F, 0.0F);
-                tessellator.addVertexWithUV(minX, maxY, minZ, sidesMaxU, sidesMinV);
-                tessellator.addVertexWithUV(minX, minY, minZ, sidesMaxU, sidesMaxV);
-                tessellator.addVertexWithUV(minX, minY, maxZ, sidesMinU, sidesMaxV);
-                tessellator.addVertexWithUV(minX, maxY, maxZ, sidesMinU, sidesMinV);
+                if (y == tilesY - 1){
+                    tessellator.setNormal(0.0F, 1.0F, 0.0F);
+                    tessellator.addVertexWithUV(maxX, maxY, minZ, topBottomMinU, topBottomMinV);
+                    tessellator.addVertexWithUV(minX, maxY, minZ, topBottomMaxU, topBottomMinV);
+                    tessellator.addVertexWithUV(minX, maxY, maxZ, topBottomMaxU, topBottomMaxV);
+                    tessellator.addVertexWithUV(maxX, maxY, maxZ, topBottomMinU, topBottomMaxV);
+                }
+                if (y == 0){
+                    tessellator.setNormal(0.0F, -1F, 0.0F);
+                    tessellator.addVertexWithUV(maxX, minY, maxZ, topBottomMinU, topBottomMinV);
+                    tessellator.addVertexWithUV(minX, minY, maxZ, topBottomMaxU, topBottomMinV);
+                    tessellator.addVertexWithUV(minX, minY, minZ, topBottomMaxU, topBottomMaxV);
+                    tessellator.addVertexWithUV(maxX, minY, minZ, topBottomMinU, topBottomMaxV);
+                }
+                if (x == tilesX - 1){
+                    tessellator.setNormal(-1F, 0.0F, 0.0F);
+                    tessellator.addVertexWithUV(maxX, maxY, maxZ, sidesMaxU, sidesMinV);
+                    tessellator.addVertexWithUV(maxX, minY, maxZ, sidesMaxU, sidesMaxV);
+                    tessellator.addVertexWithUV(maxX, minY, minZ, sidesMinU, sidesMaxV);
+                    tessellator.addVertexWithUV(maxX, maxY, minZ, sidesMinU, sidesMinV);
+                }
+                if (x == 0){
+                    tessellator.setNormal(1.0F, 0.0F, 0.0F);
+                    tessellator.addVertexWithUV(minX, maxY, minZ, sidesMaxU, sidesMinV);
+                    tessellator.addVertexWithUV(minX, minY, minZ, sidesMaxU, sidesMaxV);
+                    tessellator.addVertexWithUV(minX, minY, maxZ, sidesMinU, sidesMaxV);
+                    tessellator.addVertexWithUV(minX, maxY, maxZ, sidesMinU, sidesMinV);
+                }
                 tessellator.draw();
             }
 
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index 95f4761cb..bef9f0d97 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -144,6 +144,7 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new ItemModelStandard(Item.bone, "minecraft").setFull3D());
         addDispatch(new ItemModelStandard(Item.dustSugar, "minecraft"));
         addDispatch(new ItemModelStandard(Item.foodCake, "minecraft"));
+        addDispatch(new ItemModelStandard(Item.foodPumpkinPie, "minecraft"));
         addDispatch(new ItemModelStandard(Item.bed, "minecraft"));
         addDispatch(new ItemModelStandard(Item.repeater, "minecraft"));
         addDispatch(new ItemModelStandard(Item.foodCookie, "minecraft"));
diff --git a/src/main/java/net/minecraft/client/render/shader/Shaders.java b/src/main/java/net/minecraft/client/render/shader/Shaders.java
index ee5041077..b30f7540f 100644
--- a/src/main/java/net/minecraft/client/render/shader/Shaders.java
+++ b/src/main/java/net/minecraft/client/render/shader/Shaders.java
@@ -103,10 +103,10 @@ public abstract class Shaders {
 			shader.uniformFloat("gMod", 1.0f);
 			shader.uniformFloat("bMod", 1.0f);
 		}
-		shader.uniformFloat("photoMode", minecraft.currentScreen != null && minecraft.currentScreen instanceof GuiPhotoMode);
+		shader.uniformFloat("photoMode", minecraft.currentScreen instanceof GuiPhotoMode);
 		shader.uniformFloat("guiOpened", minecraft.currentScreen != null);
 		
-		if(minecraft.currentScreen != null && minecraft.currentScreen instanceof GuiPhotoMode) {
+		if(minecraft.currentScreen instanceof GuiPhotoMode) {
 			GuiPhotoMode guiPhotoMode = (GuiPhotoMode) minecraft.currentScreen;
 			shader.uniformFloat("intensity", guiPhotoMode.intensityValue);
 		}else {
diff --git a/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java b/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
index 5bd51824b..b5c93cd47 100644
--- a/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
+++ b/src/main/java/net/minecraft/client/render/shader/ShadersRenderer.java
@@ -239,5 +239,7 @@ public class ShadersRenderer extends Renderer {
 			return internal;
 		}
 	}
-
+	public Texture getWorldFramebufferTex(){
+		return worldFramebufferTex;
+	}
 }
diff --git a/src/main/java/net/minecraft/client/render/tessalator/Tessellator.java b/src/main/java/net/minecraft/client/render/tessalator/Tessellator.java
index cef86fbf3..40c7a5fb8 100644
--- a/src/main/java/net/minecraft/client/render/tessalator/Tessellator.java
+++ b/src/main/java/net/minecraft/client/render/tessalator/Tessellator.java
@@ -5,6 +5,7 @@ public abstract class Tessellator {
     public abstract void startDrawingQuads();
     public abstract void startDrawing(int drawMode);
     public abstract void setTextureUV(double u, double v);
+    public abstract void setLightmapCoord(int lightmapCoord);
     public abstract void setColorOpaque_F(float r, float g, float b);
     public abstract void setColorRGBA_F(float r, float g, float b, float a);
     public abstract void setColorOpaque(int r, int g, int b);
diff --git a/src/main/java/net/minecraft/client/render/tessalator/TessellatorStandard.java b/src/main/java/net/minecraft/client/render/tessalator/TessellatorStandard.java
index 05a3eec62..da405a480 100644
--- a/src/main/java/net/minecraft/client/render/tessalator/TessellatorStandard.java
+++ b/src/main/java/net/minecraft/client/render/tessalator/TessellatorStandard.java
@@ -3,6 +3,7 @@ package net.minecraft.client.render.tessalator;
 import java.nio.*;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.GLAllocation;
 import org.lwjgl.opengl.*;
 
@@ -13,8 +14,6 @@ import static org.lwjgl.opengl.GL15.GL_ARRAY_BUFFER;
 
 public class TessellatorStandard extends Tessellator
 {
-    private boolean VBOsInitialized = false;
-
     TessellatorStandard(int bufferSize)
     {
         vertexCount = 0;
@@ -31,6 +30,7 @@ public class TessellatorStandard extends Tessellator
         byteBuffer = GLAllocation.createDirectByteBuffer(bufferSize * 4);
         intBuffer = byteBuffer.asIntBuffer();
         floatBuffer = byteBuffer.asFloatBuffer();
+        shortBuffer = byteBuffer.asShortBuffer();
         rawBuffer = new int[bufferSize];
         setUseVBO(Minecraft.getMinecraft(this).gameSettings.enableVbos.value);
     }
@@ -72,6 +72,20 @@ public class TessellatorStandard extends Tessellator
                 }
                 GL11.glEnableClientState(32888 /*GL_TEXTURE_COORD_ARRAY_EXT*/);
             }
+            if(hasLightmap)
+            {
+            	GL13.glClientActiveTexture(GL13.GL_TEXTURE1);
+            	
+            	if(useVBO) {
+            		GL11.glTexCoordPointer(2, GL11.GL_SHORT, 32, 28L);
+            	} else {
+            		shortBuffer.position(14);
+            		GL11.glTexCoordPointer(2, 32, shortBuffer);
+            	}
+            	
+            	GL11.glEnableClientState(GL11.GL_TEXTURE_COORD_ARRAY);
+            	GL13.glClientActiveTexture(GL13.GL_TEXTURE0);
+            }
             if(hasColor)
             {
                 if(useVBO)
@@ -117,6 +131,12 @@ public class TessellatorStandard extends Tessellator
             {
                 GL11.glDisableClientState(32888 /*GL_TEXTURE_COORD_ARRAY_EXT*/);
             }
+            if(hasLightmap)
+            {
+            	GL13.glClientActiveTexture(GL13.GL_TEXTURE1);
+            	GL11.glDisableClientState(GL11.GL_TEXTURE_COORD_ARRAY);
+            	GL13.glClientActiveTexture(GL13.GL_TEXTURE0);
+            }
             if(hasColor)
             {
                 GL11.glDisableClientState(32886 /*GL_COLOR_ARRAY_EXT*/);
@@ -166,6 +186,18 @@ public class TessellatorStandard extends Tessellator
         textureU = u;
         textureV = v;
     }
+    
+    @Override
+    public void setLightmapCoord(int lightmapCoord) {
+    	if(!LightmapHelper.isLightmapEnabled()) {
+    		// Enabling the texture coordinates while the lightmap is disabled shouldn't cause any issues,
+    		// but it might be a little bit slower, so we make sure that never happens!
+    		
+    		throw new IllegalStateException("Lightmap is disabled!");
+    	}
+    	hasLightmap = true;
+    	this.lightmapCoord = lightmapCoord;
+    }
 
     public void setColorOpaque_F(float r, float g, float b)
     {
@@ -249,6 +281,10 @@ public class TessellatorStandard extends Tessellator
                     rawBuffer[rawBufferIndex + 3] = rawBuffer[(rawBufferIndex - j) + 3];
                     rawBuffer[rawBufferIndex + 4] = rawBuffer[(rawBufferIndex - j) + 4];
                 }
+                if(hasLightmap)
+                {
+                	rawBuffer[rawBufferIndex + 7] = rawBuffer[(rawBufferIndex - j) + 7];
+                }
                 if(hasColor)
                 {
                     rawBuffer[rawBufferIndex + 5] = rawBuffer[(rawBufferIndex - j) + 5];
@@ -266,6 +302,9 @@ public class TessellatorStandard extends Tessellator
             rawBuffer[rawBufferIndex + 3] = Float.floatToRawIntBits((float)textureU);
             rawBuffer[rawBufferIndex + 4] = Float.floatToRawIntBits((float)textureV);
         }
+        if(hasLightmap) {
+        	rawBuffer[rawBufferIndex + 7] = lightmapCoord;
+        }
         if(hasColor)
         {
             rawBuffer[rawBufferIndex + 5] = color;
@@ -364,14 +403,17 @@ public class TessellatorStandard extends Tessellator
     private ByteBuffer byteBuffer;
     private IntBuffer intBuffer;
     private FloatBuffer floatBuffer;
+    private ShortBuffer shortBuffer;
     private int rawBuffer[];
     private int vertexCount;
     private double textureU;
     private double textureV;
+    private int lightmapCoord;
     private int color;
     private boolean hasColor;
     private boolean hasTexture;
     private boolean hasNormals;
+    private boolean hasLightmap;
     private int rawBufferIndex;
     private int addedVertices;
     private boolean isColorDisabled;
diff --git a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
index 69f42776a..958efc0d4 100644
--- a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
+++ b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
@@ -16,6 +16,7 @@ public class TileEntityRendererFlag extends TileEntityRenderer<TileEntityFlag>
 
     private final ModelFlag flagModel;
     private FlagRenderer flagRenderer = null;
+    private long lastTick = 0;
     
     public TileEntityRendererFlag() 
     {
@@ -43,7 +44,11 @@ public class TileEntityRendererFlag extends TileEntityRenderer<TileEntityFlag>
         }
         flagRenderer.updateTexture(tileEntity);
 
-        float sway = (float) (((Minecraft.getMinecraft(this).theWorld.getWorldTime() + (double)partialTick) / 1.5D) % (2 * Math.PI));
+        long currentTick = Minecraft.getMinecraft(this).theWorld.getWorldTime();
+
+        float sway = (float) (((lastTick + (currentTick - lastTick) * (double)partialTick) / 1.5D) % (2 * Math.PI));
+
+        lastTick = currentTick;
 
         GL11.glPushMatrix();
         final float scale = 1F;
